#ifndef _A3KFSIO_H_
#define _A3KFSIO_H_

int getDLLMainVersion (void);
int getDLLMinorVersion (void);
char* a3ksfsErrorText(int errnum); // war orginal: int a3ksfsErrorText(int errnum);
int a3kaspiSetup(void);
int a3kVmmInitialize(void);
int a3kNumAdapters(void);
int a3kNumA3kDisks(void);

//------------------------------------------------------------------------

/* pVccb  liegt bei 1009C7E8
seems to be a DLL internal struct
*/
pVccb
{
	short	//a3kVmmMountVolume schreibt und liest hier
			// MountAll liest davon
}


//------------------------------------------------------------------------
/* aPthId
= Path Index = List of Path elements
distance of two elements is 0x80
altogether 0xF (=16) elements

a3kMountPartition() macht hier Eintrge

is initialized by a3kVmmInitialize()
*/
typedef struct
{
	long index;		// ( -1 = entry free, >0 = entry used
					//  is counted up by 0x10s when entry gets occupied)
	char MountPoint[6 oder viel mehr];	// z.b. 2:6:0
	char bytes[0x76];
} tPthIdEntry;

typedef struct
{
	tPthIdEntry PthIdEntries[16];
} tPthId;
//------------------------------------------------------------------------

//------------------------------------------------------------------------
/* aPfsId
ReadDirEntry() uses aPfsID in counts of 0x20 ( I know the FileSystem itself is counting in steps of
                                               0x20, too, so maybe this is the same information )
0 = used, -1 = free

insgesamt 1980 elemente ??
length of element is 20 Byte

bei Offset 12 wird immer hochgezhlt wenn a3kReadDirEntry aufgerufen wird.
*/

typedef struct
{
	long OpenCloseFlag;	// wird von CloseDir wieder auf -1 gesetzt
						// wird von OpenDir auf 0 gesetzt
	char unknown[8];
	short dirEntryCounter;	// ist abhngig von OpenCloseFlag und wird mit Close auf 0 rckgesetzt
	char bytes[6];
} tPfsIdEntry;
/*
FOpen() fhrt zum verwenden des 2. ten Entries und setzt OpenCloseFlag auf 1

Zhlt in 2.ter Ebene bei offset 31

Das Ende der A3kDirEntry() wird offensichtlich bei Offset 21 mit einer 1 angezeigt#
knnte aber auch ein Flag sein, das anzeigt ob gerade Files oder Folders gezhlt werden
a3kFClose() setzt diess Flag wieder auf -1
a3kFopen() setzt es auf 1
*/

typedef struct
{
	tPfsIdEntry fileSystemEntries[1980];	// seems to be too much to me, recheck !!!
}

//------------------------------------------------------------------------

//------------------------------------------------------------------------
/* aClmID
length of element 16 bytes
*/

typedef struct
{
	short entryInUse;		// 1009C420 initialized with -2
	short ;					// 1009C422 initialized with 0
	short ;
	char* ;
	short ;

	Struktur belegt im Speicher 16 Byte
	also fehlt hier noch ein long oder andere 4 Byte

} tClmIdEntry;

typedef struct		// 1009C420
{
	tClmIdEntry ClmIdEntries[50];
} ClmId;
//------------------------------------------------------------------------

//------------------------------------------------------------------------
/*
((a3kGetVolumePath() holt sich hier die Daten raus ??))

hier drin sind die Partitionsnamen gespeichert
*/
aVmmId		1008A120
{
	16x mal folgende Struktur
	{
	short;	//1008A13E
	char[20];	//1008A140 // der Diskname z.B. backup ist hier mit 0x20 gepadded drin

	long;	//1008A180
	long;
	long;
	long;
	long;
	long;
	long;
	long;
	long;
	long;	//1008A1A8
	long;
	long;
	}
}

//------------------------------------------------------------------------


// aus Ampfea = von Jay

int             a3kSfsToLocal(char *sfsName, char *LocalName);
void            a3kLocalToSfs(char *LocalName, char *sfsName, int mode);
int             a3kgetVolPath(int pathindex, char volname[64], char mountpth[12]);
int             mountpartition(int host, int scsi, int partition);
int             mountall();
int             unmountall();
void            a3kLs(char *pPath);
void            a3kMkdir(char *pPath);
void            a3kRmdir(char *pPath);
void            a3kRm(char *sfsName);
void            a3kLink(char *src, char *des);
void            a3kRename(char *src, char *des);
void            a3kCp(char *src, char *des);
void            a3kDump(char *pPath);
void            a3kFlush(char *pPath);
void            a3kStatus(void);
void            lsa3kvol(char *pPath);




#ifdef exported By A3kFSio
          1    0 00012CB0 ReleaseDevice
          2    1 00012C10 ReserveDevice
          3    2 00012AC0 ResetSCSIBus
          4    3 00012A50 ResetSCSIDevice
          5    4 00012240 ScanForA3kDisks
          6    5 00004300 a3kCacheStatus
          7    6 00002460 a3kCheckVol
          8    7 00007670 a3kCloseDir
          9    8 00002D10 a3kCluster
         10    9 00001780 a3kClusterYnode
         11    A 000021E0 a3kDump
         12    B 00007D40 a3kFClose
         13    C 000020A0 a3kFCp
         14    D 00007D00 a3kFCreate
         15    E 00007D80 a3kFEOF
         16    F 00008870 a3kFGetDataType	(char* "2:1:0\Analog Bass     \PROG\002             ")


         17   10 00008780 a3kFGetStat
         18   11 00007E90 a3kFLink
         19   12 00007DD0 a3kFMove
         20   13 00007C40 a3kFOpen
         21   14 00007D90 a3kFRead
         22   15 000082F0 a3kFRename
         23   16 00001FA0 a3kFRm
         24   17 00007D50 a3kFSeek
         25   18 000087E0 a3kFSetStat
         26   19 00007D70 a3kFTell
         27   1A 00008150 a3kFUnlink
         28   1B 00007DB0 a3kFWrite
         29   1C 00002C40 a3kFlush
         30   1D 0000B500 a3kFlushVolume
         31   1E 00008930 (int)a3kGetFileSize
         32   1F 000010A0 a3kLocalToSfs
         33   20 00001B50 a3kLs
         34   21 00001F60 a3kMkDir
         35   22 00002FB0 a3kMountAll
         36   23 00002EF0 a3kMountPartition
         37   24 00012D50 a3kNumA3kDisks
         38   25 00012D60 a3kNumAdapters
         39   26 000075D0 a3kOpenDir
         40   27 00007AD0 (int) a3kReadDirEnt
         41   28 00002060 a3kRenameAux
         42   29 000076F0 a3kRmDir
         43   2A 00007B20 a3kSeekDirEnt
         44   2B 000011C0 a3kSfsToLocal
         45   2C 00002E10 a3kStatus
         46   2D 00003050 a3kUnMountAll
         47   2E 0000DF80 a3kVmmChangeVolName
         48   2F 0000D8C0 a3kVmmFormatBootBlock
         49   30 0000DF40 a3kVmmGetMediaStatus
         50   31 0000DE70 a3kVmmGetParams
         51   32 0000DEE0 a3kVmmGetUsedSize
         52   33 0000D790 a3kVmmGetVmmInf
         53   34 0000E190 a3kVmmGetVolName
         54   35 0000D110 a3kVmmInitialize
         55   36 0000D680 a3kVmmMountPath
         56   37 0000D180 a3kVmmMountVolume
         57   38 0000D9B0 a3kVmmReadBootBlock
         58   39 0000D710 a3kVmmUnmountPath
         59   3A 0000D540 a3kVmmUnmountVolume
         60   3B 00001420 a3kYd
         61   3C 00001910 a3kYls
         62   3D 000121D0 a3kaspiQuit
         63   3E 00012150 a3kaspiSetup
         64   3F 0000AD40 a3kclmInitialize
         65   40 00002E60 a3kgetVolPath
         66   41 0000E2B0 a3kpfsInitialize
         67   42 00012D70 a3ksfsErrorText
         68   43 0009C420 aClmId
         69   44 000248E0 aPfsId
         70   45 000898E0 aPthId
         71   46 0008A120 aVmmId
         72   47 00001320 cache
         73   48 00003120 getDLLMainVersion
         74   49 00003130 getDLLMinorVersion
         75   4A 00001000 getSYSCACHEAddr
         76   4B 0000E260 getaVmmId
         77   4C 00001010 getpVccb
         78   4D 00003140 lsa3kvol
         79   4E 0009C7E8 pVccb
         80   4F 00014180 printhex
#endif

#endif /*_A3KFSIO_H_*/