//Header file for A4kDir

#ifndef A4K_DIR_H
#define A4K_DIR_H   //avoid double inclusion

#include <vcl.h>
//////Errorcodes

#define A4K_NO_OTHERS_FOUND             -9
#define A4K_NO_VOLUME_NAME_FOUND          -8
#define A4K_ERROR_READING_FILE_ENTRY    -7
#define A4K_ERROR_READING_FILE          -6
#define A4K_OPEN_FILE_FAILED            -5
#define A4K_NOT_ENOUGH_MEMORY           -4
#define A4K_STRING_TOO_SHORT            -3
#define A4K_INVALID_POINTER             -2
#define A4K_RAW_DATA_TOO_LONG           -1
#define A4K_OK                           true
#define A4K_NOK                          false


////
#define A4K_DIR_RAW_ENTRY_LENGTH 38
#define A4K_DIR_ENTRY_LENGTH     39
#define A4K_TYPE_LENGTH          6  //5 Bytes
#define A4K_NAME_LENGTH          17 //16 Bytes
const char A4K_DIR_ENTRY_EMPTY = 0xFF;
const char A4K_DIR_ENTRY_USED  = 0x00;
#define A4K_MAX_NUM_DIR_ENTRIES  257

////
const unsigned short VOLUME_NAME=0;
const unsigned short OTHERS=225;

class A4kDirEntry
{//class for one Entity in yamaha.sym
    //friend class A4kDir;
    public:
    A4kDirEntry(void);
    ~A4kDirEntry(void);
    bool SetDirEntry(char*);
    int GetLastError(void);
    bool GetDirEntry(char*);
    String ExtractString(void);
    bool IsEmpty(void);
    bool IsSample(void);
    bool IsBank(void);
    String GetName(void);

    private:
    char Occupation;
    char Type[A4K_TYPE_LENGTH];
    char Name[A4K_NAME_LENGTH];
    char DirEntry[A4K_DIR_ENTRY_LENGTH-1];
    protected:
    int errorcode;
};

class A4kDir:A4kDirEntry
{ //class for a complete directory stored in yamaha.sym
    public:
    A4kDir(void);
    ~A4kDir(void);
    bool ReadDir(void);   //get the complete information in yamaha.sym
    bool SetDirFile(char*);  //which file to examine
    int GetLastError(void);
    String GetFirstSample(void);
    String GetNextSample(void);
    bool AllSamplesParsed(void);
    unsigned int GetNumberOfSamples(void);

    //Eigenschaften
    String VolumeName;

    private:
    unsigned int SampleIndex;   //current position
    unsigned int BankIndex;
    unsigned int NumberOfSamples;
    bool bAllSamplesParsed;
    char* SymFileName;

    void SetError(int);
    bool LoadSymFile(void);
    A4kDirEntry A4kDirEntries[A4K_MAX_NUM_DIR_ENTRIES];
    bool CheckFormat(void);

//    int errorcode;


};
#endif